#!/bin/sh
#
FN="/home/meteohub/wear"
#
RPI="`cat /proc/cpuinfo | grep -e BCM2708 -e BCM2709`"
SHEEVA="`cat /proc/cpuinfo | grep -e SheevaPlug -e sun4i`"
UPT="`cat /proc/uptime | gawk '{printf "%d", $1 / 60}'`"
if [ -n "`fgrep Oxsemi /proc/cpuinfo`" ]
then
  DEV="sda"
else
  if [ -n "$RPI" ]
  then
    DEV="mmcblk0"
  else
    if [ -n "$SHEEVA" ]
    then
      DEV="`mount | grep -e "/ type" | grep "/dev" | gawk '{print $1}' |  cut -c6-12`"
    else
      DEV="`mount | grep "/ type" | grep "/dev" | gawk '{print $1}' |  cut -c6-8`"
    fi
  fi
fi
WRTS="`cat /sys/block/$DEV/stat | gawk '{print $5}'`"
BLKS="`cat /sys/block/$DEV/stat | gawk '{print $7}'`"
DISK="`cat /proc/partitions | grep ${DEV}$ | gawk '{print $3}'`"
#
OLDUPT="0"
TRGUPT="0"
OLDWRTS="0"
OLDBLKS="0"
TOTWRTS="0"
TOTBLKS="0"
#
if [ -f $FN ]
then
  OLDUPT="`cat $FN | gawk '{print $1}'`"
  TRGUPT="$((OLDUPT+$1))"
  OLDWRTS="`cat $FN | gawk '{print $2}'`"
  OLDBLKS="`cat $FN | gawk '{print $3}'`"
  TOTWRTS="`cat $FN | gawk '{print $4}'`"
  TOTBLKS="`cat $FN | gawk '{print $5}'`"
fi
#
if [ $UPT -ge $OLDUPT ]
then
  if [ $UPT -ge $TRGUPT ]
  then
    NEWWRTS="$(($WRTS-$OLDWRTS))"
    NEWBLKS="$(($BLKS-$OLDBLKS))"
    echo "$UPT $WRTS $BLKS $(($TOTWRTS+$NEWWRTS)) $(($TOTBLKS+$NEWBLKS)) $DISK" >$FN 
  fi
else
  echo "$UPT $WRTS $BLKS $(($TOTWRTS+$WRTS)) $(($TOTBLKS+$BLKS)) $DISK" >$FN 
fi
